
#include "MacroPatternMatch.h"

#include "HROOT-coreTopLevel.h"

#include "HROOTCoreTGlobal.h"

#include "HROOTCoreTDirectory.h"

#include "TROOT.h"

#include "HROOTCoreTNamed.h"

#include "TSystem.h"

#include "HROOTCoreTNamed.h"

#include "HROOTCoreTAttLine.h"

#include "HROOTCoreTAttFill.h"

#include "HROOTCoreTAttMarker.h"

#include "HROOTCoreTAttText.h"

#include "TStyle.h"

#include "HROOTCoreTROOT.h"

#include "HROOTCoreTSystem.h"

#include "HROOTCoreTStyle.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )

TROOT_p TopLevel_GetROOT (  ) {
return from_nonconst_to_nonconst<TROOT_t, TROOT>((TROOT*)GetROOT());
}

TROOT_p TopLevel_gROOT (  ) {
return from_nonconst_to_nonconst<TROOT_t, TROOT>((TROOT*)gROOT);
}

TSystem_p TopLevel_gSystem (  ) {
return from_nonconst_to_nonconst<TSystem_t, TSystem>((TSystem*)gSystem);
}

TStyle_p TopLevel_gStyle (  ) {
return from_nonconst_to_nonconst<TStyle_t, TStyle>((TStyle*)gStyle);
}

