
#include "MacroPatternMatch.h"

#include "HROOTCoreTArray.h"

#include "TArrayF.h"

#include "HROOTCoreTArrayF.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TARRAY_DEF_VIRT(TArrayF)
DELETABLE_DEF_VIRT(TArrayF)
TARRAYF_DEF_VIRT(TArrayF)
TARRAYF_DEF_NONVIRT(TArrayF)
TARRAYF_DEF_ACCESSOR(TArrayF)

