
#include "MacroPatternMatch.h"

#include "HROOTCoreTArray.h"

#include "TArrayL.h"

#include "HROOTCoreTArrayL.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TARRAY_DEF_VIRT(TArrayL)
DELETABLE_DEF_VIRT(TArrayL)
TARRAYL_DEF_VIRT(TArrayL)
TARRAYL_DEF_NONVIRT(TArrayL)
TARRAYL_DEF_ACCESSOR(TArrayL)

