
#include "MacroPatternMatch.h"

#include "HROOTCoreTObject.h"

#include "HROOTCoreTKey.h"

#include "HROOTCoreTNamed.h"

#include "TDirectory.h"

#include "HROOTCoreTDirectory.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TNAMED_DEF_VIRT(TDirectory)
TOBJECT_DEF_VIRT(TDirectory)
DELETABLE_DEF_VIRT(TDirectory)
TDIRECTORY_DEF_VIRT(TDirectory)
TDIRECTORY_DEF_NONVIRT(TDirectory)
TDIRECTORY_DEF_ACCESSOR(TDirectory)

