
#include "MacroPatternMatch.h"

#include "HROOTCoreTClass.h"

#include "HROOTCoreTDirectory.h"

#include "HROOTCoreTNamed.h"

#include "TKey.h"

#include "HROOTCoreTKey.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TNAMED_DEF_VIRT(TKey)
TOBJECT_DEF_VIRT(TKey)
DELETABLE_DEF_VIRT(TKey)
TKEY_DEF_VIRT(TKey)
TKEY_DEF_NONVIRT(TKey)
TKEY_DEF_ACCESSOR(TKey)

