
#include "MacroPatternMatch.h"

#include "HROOTCoreTNamed.h"

#include "TSystem.h"

#include "HROOTCoreTSystem.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TNAMED_DEF_VIRT(TSystem)
TOBJECT_DEF_VIRT(TSystem)
DELETABLE_DEF_VIRT(TSystem)
TSYSTEM_DEF_VIRT(TSystem)
TSYSTEM_DEF_NONVIRT(TSystem)
TSYSTEM_DEF_ACCESSOR(TSystem)

