{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module HROOT.Core.Rectangle_t.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import HROOT.Core.Rectangle_t.RawType
import HROOT.Core.Rectangle_t.RawType

foreign import ccall interruptible
               "HROOTCoreRectangle_t.h Rectangle_t_delete" c_rectangle_t_delete ::
               Ptr RawRectangle_t -> IO ()

foreign import ccall interruptible "Rectangle_t_fHeight_get"
               c_rectangle_t_fheight_get :: Ptr RawRectangle_t -> IO CUShort

foreign import ccall interruptible "Rectangle_t_fHeight_set"
               c_rectangle_t_fheight_set :: Ptr RawRectangle_t -> CUShort -> IO ()

foreign import ccall interruptible "Rectangle_t_fWidth_get"
               c_rectangle_t_fwidth_get :: Ptr RawRectangle_t -> IO CUShort

foreign import ccall interruptible "Rectangle_t_fWidth_set"
               c_rectangle_t_fwidth_set :: Ptr RawRectangle_t -> CUShort -> IO ()

foreign import ccall interruptible "Rectangle_t_fX_get"
               c_rectangle_t_fx_get :: Ptr RawRectangle_t -> IO CShort

foreign import ccall interruptible "Rectangle_t_fX_set"
               c_rectangle_t_fx_set :: Ptr RawRectangle_t -> CShort -> IO ()

foreign import ccall interruptible "Rectangle_t_fY_get"
               c_rectangle_t_fy_get :: Ptr RawRectangle_t -> IO CShort

foreign import ccall interruptible "Rectangle_t_fY_set"
               c_rectangle_t_fy_set :: Ptr RawRectangle_t -> CShort -> IO ()
