{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Core.TArrayL64.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Core.TArrayL64.RawType
import HROOT.Core.TArrayL64.FFI
import HROOT.Core.TArrayL64.Interface
import HROOT.Core.TArrayL64.Cast
import HROOT.Core.TArrayL64.RawType
import HROOT.Core.TArrayL64.Cast
import HROOT.Core.TArrayL64.Interface
import HROOT.Core.TArray.RawType
import HROOT.Core.TArray.Cast
import HROOT.Core.TArray.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITArrayL64 (TArrayL64) where

instance () => ITArray (TArrayL64) where
        getAt = xform1 c_tarrayl64_getat
        setArray = xform1 c_tarrayl64_setarray
        setAt = xform2 c_tarrayl64_setat

instance () => IDeletable (TArrayL64) where
        delete = xform0 c_tarrayl64_delete
