{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TAttBBox2D.Interface where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Core.TAttBBox2D.RawType
import HROOT.Core.Rectangle_t.RawType
import STD.Deletable.Interface

class (IDeletable a) => ITAttBBox2D a where
        getBBox :: () => a -> IO Rectangle_t
        
        setBBoxX1 :: () => a -> CInt -> IO ()
        
        setBBoxX2 :: () => a -> CInt -> IO ()
        
        setBBoxY1 :: () => a -> CInt -> IO ()
        
        setBBoxY2 :: () => a -> CInt -> IO ()
