{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Core.TAttFill.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.FFI
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITAttFill (TAttFill) where
        setFillColor = xform1 c_tattfill_setfillcolor
        setFillStyle = xform1 c_tattfill_setfillstyle

instance () => IDeletable (TAttFill) where
        delete = xform0 c_tattfill_delete

newTAttFill :: () => CShort -> CShort -> IO TAttFill
newTAttFill = xform1 c_tattfill_newtattfill
