{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TAttFill.Interface where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Core.TAttFill.RawType
import STD.Deletable.Interface

class (IDeletable a) => ITAttFill a where
        setFillColor :: () => a -> CInt -> IO ()
        
        setFillStyle :: () => a -> CInt -> IO ()

upcastTAttFill :: forall a . (FPtr a, ITAttFill a) => a -> TAttFill
upcastTAttFill h
  = let fh = get_fptr h
        fh2 :: Ptr RawTAttFill = castPtr fh
      in cast_fptr_to_obj fh2

downcastTAttFill ::
                 forall a . (FPtr a, ITAttFill a) => TAttFill -> a
downcastTAttFill h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
