{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module HROOT.Core.TAttLine.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.RawType

foreign import ccall interruptible
               "HROOTCoreTAttLine.h TAttLine_delete" c_tattline_delete ::
               Ptr RawTAttLine -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttLine.h TAttLine_newTAttLine" c_tattline_newtattline
               :: CShort -> CShort -> CShort -> IO (Ptr RawTAttLine)

foreign import ccall interruptible
               "HROOTCoreTAttLine.h TAttLine_tAttLine_DistancetoLine"
               c_tattline_tattline_distancetoline ::
               Ptr RawTAttLine ->
                 CInt -> CInt -> CDouble -> CDouble -> CDouble -> CDouble -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTAttLine.h TAttLine_GetLineColor" c_tattline_getlinecolor
               :: Ptr RawTAttLine -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTAttLine.h TAttLine_GetLineStyle" c_tattline_getlinestyle
               :: Ptr RawTAttLine -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTAttLine.h TAttLine_GetLineWidth" c_tattline_getlinewidth
               :: Ptr RawTAttLine -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTAttLine.h TAttLine_ResetAttLine" c_tattline_resetattline
               :: Ptr RawTAttLine -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttLine.h TAttLine_SetLineAttributes"
               c_tattline_setlineattributes :: Ptr RawTAttLine -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttLine.h TAttLine_SetLineColor" c_tattline_setlinecolor
               :: Ptr RawTAttLine -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttLine.h TAttLine_SetLineStyle" c_tattline_setlinestyle
               :: Ptr RawTAttLine -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttLine.h TAttLine_SetLineWidth" c_tattline_setlinewidth
               :: Ptr RawTAttLine -> CShort -> IO ()
