{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Core.TAttLine.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.FFI
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITAttLine (TAttLine) where
        getLineColor = xform0 c_tattline_getlinecolor
        getLineStyle = xform0 c_tattline_getlinestyle
        getLineWidth = xform0 c_tattline_getlinewidth
        resetAttLine = xform1 c_tattline_resetattline
        setLineAttributes = xform0 c_tattline_setlineattributes
        setLineColor = xform1 c_tattline_setlinecolor
        setLineStyle = xform1 c_tattline_setlinestyle
        setLineWidth = xform1 c_tattline_setlinewidth

instance () => IDeletable (TAttLine) where
        delete = xform0 c_tattline_delete

newTAttLine :: () => CShort -> CShort -> CShort -> IO TAttLine
newTAttLine = xform2 c_tattline_newtattline

tAttLine_DistancetoLine ::
                          () =>
                          TAttLine ->
                            CInt -> CInt -> CDouble -> CDouble -> CDouble -> CDouble -> IO CInt
tAttLine_DistancetoLine = xform6 c_tattline_tattline_distancetoline
