{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Core.TClass.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.FFI
import HROOT.Core.TClass.Interface
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TDictionary.RawType
import HROOT.Core.TDictionary.Cast
import HROOT.Core.TDictionary.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITClass (TClass) where

instance () => ITDictionary (TClass) where

instance () => ITNamed (TClass) where
        setName = xform1 c_tclass_setname
        setNameTitle = xform2 c_tclass_setnametitle
        setTitle = xform1 c_tclass_settitle

instance () => ITObject (TClass) where
        clear = xform1 c_tclass_clear
        draw = xform1 c_tclass_draw
        findObject = xform1 c_tclass_findobject
        getName = xform0 c_tclass_getname
        isA = xform0 c_tclass_isa
        paint = xform1 c_tclass_paint
        printObj = xform1 c_tclass_printobj
        saveAs = xform2 c_tclass_saveas
        write = xform3 c_tclass_write
        write_ = xform0 c_tclass_write_

instance () => IDeletable (TClass) where
        delete = xform0 c_tclass_delete
