{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module HROOT.Core.TCollection.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import HROOT.Core.TCollection.RawType
import HROOT.Core.TCollection.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TClass.RawType

foreign import ccall interruptible
               "HROOTCoreTCollection.h TCollection_Clear" c_tcollection_clear ::
               Ptr RawTCollection -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTCollection.h TCollection_Draw" c_tcollection_draw ::
               Ptr RawTCollection -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTCollection.h TCollection_FindObject"
               c_tcollection_findobject ::
               Ptr RawTCollection -> CString -> IO (Ptr RawTObject)

foreign import ccall interruptible
               "HROOTCoreTCollection.h TCollection_GetName" c_tcollection_getname
               :: Ptr RawTCollection -> IO CString

foreign import ccall interruptible
               "HROOTCoreTCollection.h TCollection_IsA" c_tcollection_isa ::
               Ptr RawTCollection -> IO (Ptr RawTClass)

foreign import ccall interruptible
               "HROOTCoreTCollection.h TCollection_Paint" c_tcollection_paint ::
               Ptr RawTCollection -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTCollection.h TCollection_printObj"
               c_tcollection_printobj :: Ptr RawTCollection -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTCollection.h TCollection_SaveAs" c_tcollection_saveas ::
               Ptr RawTCollection -> CString -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTCollection.h TCollection_Write" c_tcollection_write ::
               Ptr RawTCollection -> CString -> CInt -> CInt -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTCollection.h TCollection_Write_" c_tcollection_write_ ::
               Ptr RawTCollection -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTCollection.h TCollection_delete" c_tcollection_delete ::
               Ptr RawTCollection -> IO ()
