{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module HROOT.Core.TDatime.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import HROOT.Core.TDatime.RawType
import HROOT.Core.TDatime.RawType

foreign import ccall interruptible
               "HROOTCoreTDatime.h TDatime_delete" c_tdatime_delete ::
               Ptr RawTDatime -> IO ()

foreign import ccall interruptible
               "HROOTCoreTDatime.h TDatime_newTDatime" c_tdatime_newtdatime ::
               CInt -> CInt -> CInt -> CInt -> CInt -> CInt -> IO (Ptr RawTDatime)

foreign import ccall interruptible
               "HROOTCoreTDatime.h TDatime_Convert" c_tdatime_convert ::
               Ptr RawTDatime -> CBool -> IO CUInt

foreign import ccall interruptible
               "HROOTCoreTDatime.h TDatime_tDatime_GetDay"
               c_tdatime_tdatime_getday :: Ptr RawTDatime -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTDatime.h TDatime_tDatime_GetHour"
               c_tdatime_tdatime_gethour :: Ptr RawTDatime -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTDatime.h TDatime_tDatime_GetMinute"
               c_tdatime_tdatime_getminute :: Ptr RawTDatime -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTDatime.h TDatime_tDatime_GetSecond"
               c_tdatime_tdatime_getsecond :: Ptr RawTDatime -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTDatime.h TDatime_tDatime_GetYear"
               c_tdatime_tdatime_getyear :: Ptr RawTDatime -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTDatime.h TDatime_tDatime_GetMonth"
               c_tdatime_tdatime_getmonth :: Ptr RawTDatime -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTDatime.h TDatime_setTDatime" c_tdatime_settdatime ::
               Ptr RawTDatime -> CUInt -> IO ()
