{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Core.TDatime.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Core.TDatime.RawType
import HROOT.Core.TDatime.FFI
import HROOT.Core.TDatime.Interface
import HROOT.Core.TDatime.Cast
import HROOT.Core.TDatime.RawType
import HROOT.Core.TDatime.Cast
import HROOT.Core.TDatime.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITDatime (TDatime) where
        convert = xform1 c_tdatime_convert
        setTDatime = xform1 c_tdatime_settdatime

instance () => IDeletable (TDatime) where
        delete = xform0 c_tdatime_delete

newTDatime ::
             () => CInt -> CInt -> CInt -> CInt -> CInt -> CInt -> IO TDatime
newTDatime = xform5 c_tdatime_newtdatime

tDatime_GetDay :: () => TDatime -> IO CInt
tDatime_GetDay = xform0 c_tdatime_tdatime_getday

tDatime_GetHour :: () => TDatime -> IO CInt
tDatime_GetHour = xform0 c_tdatime_tdatime_gethour

tDatime_GetMinute :: () => TDatime -> IO CInt
tDatime_GetMinute = xform0 c_tdatime_tdatime_getminute

tDatime_GetSecond :: () => TDatime -> IO CInt
tDatime_GetSecond = xform0 c_tdatime_tdatime_getsecond

tDatime_GetYear :: () => TDatime -> IO CInt
tDatime_GetYear = xform0 c_tdatime_tdatime_getyear

tDatime_GetMonth :: () => TDatime -> IO CInt
tDatime_GetMonth = xform0 c_tdatime_tdatime_getmonth
