{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TDatime.Interface where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Core.TDatime.RawType
import STD.Deletable.Interface

class (IDeletable a) => ITDatime a where
        convert :: () => a -> CBool -> IO CUInt
        
        setTDatime :: () => a -> CUInt -> IO ()

upcastTDatime :: forall a . (FPtr a, ITDatime a) => a -> TDatime
upcastTDatime h
  = let fh = get_fptr h
        fh2 :: Ptr RawTDatime = castPtr fh
      in cast_fptr_to_obj fh2

downcastTDatime :: forall a . (FPtr a, ITDatime a) => TDatime -> a
downcastTDatime h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
