
#include "MacroPatternMatch.h"

#include "HROOTCoreTObject.h"

#include "HROOTCoreTQObject.h"

#include "TApplication.h"

#include "HROOTCoreTApplication.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TOBJECT_DEF_VIRT(TApplication)
TQOBJECT_DEF_VIRT(TApplication)
DELETABLE_DEF_VIRT(TApplication)
TAPPLICATION_DEF_VIRT(TApplication)
TAPPLICATION_DEF_NONVIRT(TApplication)
TAPPLICATION_DEF_ACCESSOR(TApplication)

