
#ifdef __cplusplus
extern "C" {
#endif

#pragma once


#include "HROOT-coreType.h"

#include "STDDeletable.h"

#include "stdcxxType.h"


#define TATTMARKER_DECL_VIRT(Type) \
short Type##_GetMarkerColor ( Type##_p p );\
short Type##_GetMarkerStyle ( Type##_p p );\
float Type##_GetMarkerSize ( Type##_p p );\
void Type##_ResetAttMarker ( Type##_p p, const char* option );\
void Type##_SetMarkerAttributes ( Type##_p p );\
void Type##_SetMarkerColor ( Type##_p p, short tcolor );\
void Type##_SetMarkerStyle ( Type##_p p, short mstyle );\
void Type##_SetMarkerSize ( Type##_p p, short msize );


#define TATTMARKER_DECL_NONVIRT(Type) \
Type##_p Type##_newTAttMarker ( short color, short style, short msize );


#define TATTMARKER_DECL_ACCESSOR(Type) \



#define TATTMARKER_DEF_VIRT(Type) \
short Type##_GetMarkerColor ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, GetMarkerColor, TAttMarker))(p))->GetMarkerColor();\
}\
\
short Type##_GetMarkerStyle ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, GetMarkerStyle, TAttMarker))(p))->GetMarkerStyle();\
}\
\
float Type##_GetMarkerSize ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, GetMarkerSize, TAttMarker))(p))->GetMarkerSize();\
}\
\
void Type##_ResetAttMarker ( Type##_p p, const char* option ) {\
((TYPECASTMETHOD(Type, ResetAttMarker, TAttMarker))(p))->ResetAttMarker(option);\
}\
\
void Type##_SetMarkerAttributes ( Type##_p p ) {\
((TYPECASTMETHOD(Type, SetMarkerAttributes, TAttMarker))(p))->SetMarkerAttributes();\
}\
\
void Type##_SetMarkerColor ( Type##_p p, short tcolor ) {\
((TYPECASTMETHOD(Type, SetMarkerColor, TAttMarker))(p))->SetMarkerColor(tcolor);\
}\
\
void Type##_SetMarkerStyle ( Type##_p p, short mstyle ) {\
((TYPECASTMETHOD(Type, SetMarkerStyle, TAttMarker))(p))->SetMarkerStyle(mstyle);\
}\
\
void Type##_SetMarkerSize ( Type##_p p, short msize ) {\
((TYPECASTMETHOD(Type, SetMarkerSize, TAttMarker))(p))->SetMarkerSize(msize);\
}


#define TATTMARKER_DEF_NONVIRT(Type) \
Type##_p Type##_newTAttMarker ( short color, short style, short msize ) {\
Type* newp=new Type(color, style, msize);return from_nonconst_to_nonconst<Type##_t, Type>(newp);\
}


#define TATTMARKER_DEF_ACCESSOR(Type) \



DELETABLE_DECL_VIRT(TAttMarker)
TATTMARKER_DECL_VIRT(TAttMarker)
TATTMARKER_DECL_NONVIRT(TAttMarker)
TATTMARKER_DECL_ACCESSOR(TAttMarker)

#ifdef __cplusplus
}
#endif

