
#include "MacroPatternMatch.h"

#include "HROOTCoreTObject.h"

#include "TCollection.h"

#include "HROOTCoreTCollection.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TOBJECT_DEF_VIRT(TCollection)
DELETABLE_DEF_VIRT(TCollection)
TCOLLECTION_DEF_VIRT(TCollection)
TCOLLECTION_DEF_NONVIRT(TCollection)
TCOLLECTION_DEF_ACCESSOR(TCollection)

