
#include "MacroPatternMatch.h"

#include "HROOTCoreTArrayI.h"

#include "HROOTCoreTNamed.h"

#include "TColor.h"

#include "HROOTCoreTColor.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TNAMED_DEF_VIRT(TColor)
TOBJECT_DEF_VIRT(TColor)
DELETABLE_DEF_VIRT(TColor)
TCOLOR_DEF_VIRT(TColor)
TCOLOR_DEF_NONVIRT(TColor)
TCOLOR_DEF_ACCESSOR(TColor)

