
#include "MacroPatternMatch.h"

#include "HROOTCoreTObject.h"

#include "TNamed.h"

#include "HROOTCoreTNamed.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TOBJECT_DEF_VIRT(TNamed)
DELETABLE_DEF_VIRT(TNamed)
TNAMED_DEF_VIRT(TNamed)
TNAMED_DEF_NONVIRT(TNamed)
TNAMED_DEF_ACCESSOR(TNamed)

