
#include "MacroPatternMatch.h"

#include "HROOTCoreTClass.h"

#include "STDDeletable.h"

#include "TObject.h"

#include "HROOTCoreTObject.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

DELETABLE_DEF_VIRT(TObject)
TOBJECT_DEF_VIRT(TObject)
TOBJECT_DEF_NONVIRT(TObject)
TOBJECT_DEF_ACCESSOR(TObject)

