
#include "MacroPatternMatch.h"

#include "HROOTCoreTObject.h"

#include "HROOTCoreTAttLine.h"

#include "HROOTCoreTAttFill.h"

#include "HROOTCoreTAttPad.h"

#include "HROOTCoreTQObject.h"

#include "TVirtualPad.h"

#include "HROOTCoreTVirtualPad.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TOBJECT_DEF_VIRT(TVirtualPad)
TATTLINE_DEF_VIRT(TVirtualPad)
TATTFILL_DEF_VIRT(TVirtualPad)
TATTPAD_DEF_VIRT(TVirtualPad)
TQOBJECT_DEF_VIRT(TVirtualPad)
DELETABLE_DEF_VIRT(TVirtualPad)
TVIRTUALPAD_DEF_VIRT(TVirtualPad)
TVIRTUALPAD_DEF_NONVIRT(TVirtualPad)
TVIRTUALPAD_DEF_ACCESSOR(TVirtualPad)

