{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module HROOT.Core.TArrayI.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import HROOT.Core.TArrayI.RawType
import HROOT.Core.TArrayI.RawType

foreign import ccall interruptible
               "HROOTCoreTArrayI.h TArrayI_GetAt" c_tarrayi_getat ::
               Ptr RawTArrayI -> CInt -> IO CDouble

foreign import ccall interruptible
               "HROOTCoreTArrayI.h TArrayI_SetArray" c_tarrayi_setarray ::
               Ptr RawTArrayI -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTArrayI.h TArrayI_SetAt" c_tarrayi_setat ::
               Ptr RawTArrayI -> CDouble -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTArrayI.h TArrayI_delete" c_tarrayi_delete ::
               Ptr RawTArrayI -> IO ()
