{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module HROOT.Core.TArrayL64.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import HROOT.Core.TArrayL64.RawType
import HROOT.Core.TArrayL64.RawType

foreign import ccall interruptible
               "HROOTCoreTArrayL64.h TArrayL64_GetAt" c_tarrayl64_getat ::
               Ptr RawTArrayL64 -> CInt -> IO CDouble

foreign import ccall interruptible
               "HROOTCoreTArrayL64.h TArrayL64_SetArray" c_tarrayl64_setarray ::
               Ptr RawTArrayL64 -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTArrayL64.h TArrayL64_SetAt" c_tarrayl64_setat ::
               Ptr RawTArrayL64 -> CDouble -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTArrayL64.h TArrayL64_delete" c_tarrayl64_delete ::
               Ptr RawTArrayL64 -> IO ()
