{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module HROOT.Core.TAttPad.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import HROOT.Core.TAttPad.RawType
import HROOT.Core.TAttPad.RawType

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_delete" c_tattpad_delete ::
               Ptr RawTAttPad -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_newTAttPad" c_tattpad_newtattpad ::
               IO (Ptr RawTAttPad)

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_GetBottomMargin"
               c_tattpad_tattpad_getbottommargin :: Ptr RawTAttPad -> IO CFloat

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_GetLeftMargin"
               c_tattpad_tattpad_getleftmargin :: Ptr RawTAttPad -> IO CFloat

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_GetRightMargin"
               c_tattpad_tattpad_getrightmargin :: Ptr RawTAttPad -> IO CFloat

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_GetTopMargin"
               c_tattpad_tattpad_gettopmargin :: Ptr RawTAttPad -> IO CFloat

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_GetAfile"
               c_tattpad_tattpad_getafile :: Ptr RawTAttPad -> IO CFloat

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_GetXfile"
               c_tattpad_tattpad_getxfile :: Ptr RawTAttPad -> IO CFloat

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_GetYfile"
               c_tattpad_tattpad_getyfile :: Ptr RawTAttPad -> IO CFloat

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_GetAstat"
               c_tattpad_tattpad_getastat :: Ptr RawTAttPad -> IO CFloat

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_GetXstat"
               c_tattpad_tattpad_getxstat :: Ptr RawTAttPad -> IO CFloat

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_GetYstat"
               c_tattpad_tattpad_getystat :: Ptr RawTAttPad -> IO CFloat

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_GetFrameFillColor"
               c_tattpad_tattpad_getframefillcolor :: Ptr RawTAttPad -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_GetFrameLineColor"
               c_tattpad_tattpad_getframelinecolor :: Ptr RawTAttPad -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_GetFrameFillStyle"
               c_tattpad_tattpad_getframefillstyle :: Ptr RawTAttPad -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_GetFrameLineStyle"
               c_tattpad_tattpad_getframelinestyle :: Ptr RawTAttPad -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_GetFrameLineWidth"
               c_tattpad_tattpad_getframelinewidth :: Ptr RawTAttPad -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_GetFrameBorderSize"
               c_tattpad_tattpad_getframebordersize :: Ptr RawTAttPad -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_GetFrameBorderMode"
               c_tattpad_tattpad_getframebordermode :: Ptr RawTAttPad -> IO CShort

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_ResetAttPad" c_tattpad_resetattpad ::
               Ptr RawTAttPad -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_SetBottomMargin"
               c_tattpad_setbottommargin :: Ptr RawTAttPad -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_SetLeftMargin" c_tattpad_setleftmargin
               :: Ptr RawTAttPad -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_SetRightMargin"
               c_tattpad_setrightmargin :: Ptr RawTAttPad -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_SetTopMargin" c_tattpad_settopmargin ::
               Ptr RawTAttPad -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_SetMargin" c_tattpad_setmargin ::
               Ptr RawTAttPad -> CFloat -> CFloat -> CFloat -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_SetAfile" c_tattpad_setafile ::
               Ptr RawTAttPad -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_SetXfile" c_tattpad_setxfile ::
               Ptr RawTAttPad -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_SetYfile" c_tattpad_setyfile ::
               Ptr RawTAttPad -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_SetAstat" c_tattpad_setastat ::
               Ptr RawTAttPad -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_SetXstat" c_tattpad_setxstat ::
               Ptr RawTAttPad -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_SetYstat" c_tattpad_setystat ::
               Ptr RawTAttPad -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_SetFrameFillColor"
               c_tattpad_tattpad_setframefillcolor ::
               Ptr RawTAttPad -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_SetFrameLineColor"
               c_tattpad_tattpad_setframelinecolor ::
               Ptr RawTAttPad -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_SetFrameFillStyle"
               c_tattpad_tattpad_setframefillstyle ::
               Ptr RawTAttPad -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_SetFrameLineStyle"
               c_tattpad_tattpad_setframelinestyle ::
               Ptr RawTAttPad -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_SetFrameLineWidth"
               c_tattpad_tattpad_setframelinewidth ::
               Ptr RawTAttPad -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_SetFrameBorderSize"
               c_tattpad_tattpad_setframebordersize ::
               Ptr RawTAttPad -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTCoreTAttPad.h TAttPad_tAttPad_SetFrameBorderMode"
               c_tattpad_tattpad_setframebordermode ::
               Ptr RawTAttPad -> CInt -> IO ()
