{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module HROOT.Core.TGlobal.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import HROOT.Core.TGlobal.RawType
import HROOT.Core.TGlobal.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TClass.RawType

foreign import ccall interruptible
               "HROOTCoreTGlobal.h TGlobal_SetName" c_tglobal_setname ::
               Ptr RawTGlobal -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTGlobal.h TGlobal_SetNameTitle" c_tglobal_setnametitle ::
               Ptr RawTGlobal -> CString -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTGlobal.h TGlobal_SetTitle" c_tglobal_settitle ::
               Ptr RawTGlobal -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTGlobal.h TGlobal_Clear" c_tglobal_clear ::
               Ptr RawTGlobal -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTGlobal.h TGlobal_Draw" c_tglobal_draw ::
               Ptr RawTGlobal -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTGlobal.h TGlobal_FindObject" c_tglobal_findobject ::
               Ptr RawTGlobal -> CString -> IO (Ptr RawTObject)

foreign import ccall interruptible
               "HROOTCoreTGlobal.h TGlobal_GetName" c_tglobal_getname ::
               Ptr RawTGlobal -> IO CString

foreign import ccall interruptible "HROOTCoreTGlobal.h TGlobal_IsA"
               c_tglobal_isa :: Ptr RawTGlobal -> IO (Ptr RawTClass)

foreign import ccall interruptible
               "HROOTCoreTGlobal.h TGlobal_Paint" c_tglobal_paint ::
               Ptr RawTGlobal -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTGlobal.h TGlobal_printObj" c_tglobal_printobj ::
               Ptr RawTGlobal -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTGlobal.h TGlobal_SaveAs" c_tglobal_saveas ::
               Ptr RawTGlobal -> CString -> CString -> IO ()

foreign import ccall interruptible
               "HROOTCoreTGlobal.h TGlobal_Write" c_tglobal_write ::
               Ptr RawTGlobal -> CString -> CInt -> CInt -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTGlobal.h TGlobal_Write_" c_tglobal_write_ ::
               Ptr RawTGlobal -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTGlobal.h TGlobal_delete" c_tglobal_delete ::
               Ptr RawTGlobal -> IO ()
